
import java.applet.Applet;
import java.awt.Choice;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Label;
import java.awt.Canvas;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Cursor;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;

import java.lang.Integer;

import java.util.Arrays;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Comparator;
import java.util.TreeSet;
//import java.util.Iterator;


/*********************************************
 *
 *********************************************/
public class LineSegment extends Applet
implements ActionListener, ItemListener {
	
//	String redInput[] = {"None", "red16", "red64", "red256"};
//	String blueInput[] = {"None", "blue16", "blue64", "blue256"};
	Checkbox	blackLine;

	Button	btnClear;
	Button	btnSweep;
	Button btnStep;
	Choice results;

	WhiteBoard  theWhiteBoard;
	Vector	figures;
	Color currentColor;
	Label		status; 
	Label	nouse;

	int xSweep = 0;
	int xMax;
	int yMax;
	Color cSweep = Color.green;
  Endpoint minPoint;
  int countMin = 0;
  int numberIntersections = 0;
  Node minNode;
  Node newMinNode;
  Endpoint minEndpoint;
  Endpoint aEndpoint;
  Point Line1SuccessorPoint1;
  Point Line1SuccessorPoint2;
  Point Line2PredecessorPoint1;
  Point Line2PredecessorPoint2;
  
	//Vector endpoints = new Vector();
  RedBlackTree endpoints = new RedBlackTree();
  RedBlackTree yStructure = new RedBlackTree();
  Vector readEndpoints = new Vector();
	Vector lines = new Vector();
	int noOfRed = 0;
	int noOfBlue = 0;
	int stepFlag = 0;

	OrderYLines cmp2;


	/*********************************************
	 *
	 *********************************************/
	public void init() {
		setLayout( new BorderLayout() );
		setBackground( Color.lightGray);
		Panel theControlPanel = makeControlPanel();
		theControlPanel.setBackground( Color.lightGray);
		add( theControlPanel, BorderLayout.WEST );
		add( makeButtonPanel(), BorderLayout.NORTH);
		status = new Label();
		nouse = new Label();
		figures = new Vector();
		add( status, BorderLayout.SOUTH);
		add( nouse, BorderLayout.EAST);
		theWhiteBoard = new WhiteBoard();
		add( theWhiteBoard, BorderLayout.CENTER );
		theWhiteBoard.setBackground( Color.white);
	}

	/*********************************************
	 *
	 *********************************************/
	private Panel makeButtonPanel() {
		Panel p = new Panel();
		p.setLayout( new GridLayout(1,3) );
		btnClear = addButton( "Clear", p );
		btnSweep = addButton( "Sweep", p );
		btnStep = addButton("Show Step", p);
		return p;
	}

	/*********************************************
	 *
	 *********************************************/
	private Button addButton( String caption, Panel p ) {
		Button b = new Button( caption );
		p.add(b);
		b.addActionListener( this );
		return b;
	}

	/*********************************************
	 *
	 *********************************************/
	private Panel makeControlPanel() {
		Panel p = new Panel();
		p.setLayout( new GridLayout(0,1) );

		// make draw line segement buttons
		CheckboxGroup dlbg = new CheckboxGroup();
		currentColor = Color.black;
		blackLine = addRadioButton( "Draw Lines", dlbg, true, p );
		blackLine.setForeground(Color.black);

		// Display the reported intersections
		Panel reportResults = new Panel();
		reportResults.setLayout( new GridLayout(6,1) );
		Label lbl = new Label( "Reported Intersections" );
		reportResults.add(lbl);
		results = new Choice();
		reportResults.add( results);
		reportResults.setForeground(Color.black);
		p.add( reportResults );

		return p;

	}
	
	/*********************************************
	 *
	 *********************************************/
	private Checkbox addRadioButton( String caption, 
	CheckboxGroup dlbg, boolean on, Panel p ) {
		Checkbox c = new Checkbox( caption, dlbg, on );
		c.addItemListener( this );
		p.add(c);
		return c;
	}
	
	/*********************************************
	 *
	 *********************************************/
	public void actionPerformed( ActionEvent e ) {

		if ( e.getSource() == btnClear ) {
			noOfRed = 0;
			noOfBlue = 0;
			stepFlag = 0;
			figures.removeAllElements();
			yStructure = new RedBlackTree();
			//endpoints.removeAllElements();
			endpoints = new RedBlackTree();
            lines.removeAllElements();
			results.removeAll();
			readEndpoints.removeAllElements();
			theWhiteBoard.repaint();
			status.setText("clear up");
		}
		if ( e.getSource() == btnSweep ) {
			//status.setText("Sweeping ... ");
			theWhiteBoard.sweep();
		}
		if (e.getSource() == btnStep)
		{
			status.setText("Sweeping step by step... ");
			theWhiteBoard.showStep();
		}
	}

	/*********************************************
	 *
	 *********************************************/
	public void itemStateChanged(ItemEvent e) {
		Object obj = e.getSource();
		if ( obj == blackLine ) {
			status.setText( "Ready to draw a line." );
			currentColor = Color.red;
		} 
	}

/*****************************************************************
	 * Inner class DoodleCanvas
	 *****************************************************************/
	class WhiteBoard extends Canvas 
	implements MouseListener, MouseMotionListener{
		Point pointOne;
		Point pointTwo;
		Line  Line;
		Object sortPoints[];
//		Object sortLines[];

		Endpoint theEndpoint;
		RedBlackTree treeEndpoints; 
		TreeSet blueList;
		
		int iSweep = 0;
		int xRed[] ;
		int noOfLines = 0;
		String lLabel;
		Object iterRed[], iterBlue[];





		public WhiteBoard() {
			addMouseListener(this);
			addMouseMotionListener(this);

		}
	
		/*********************************************
		 *
		 *********************************************/
		public void paint( Graphics g ) {
			Enumeration e;
			e = figures.elements();
			while ( e.hasMoreElements() ) {
				Figure obj = (Figure)(e.nextElement());
				obj.draw(g);
			}
		}

		/*********************************************
		 *
		 *********************************************/
		public void initSweep() {
			OrderXEndpoints cmp1;
//			OrderXLines cmp3;
			cmp1 = new OrderXEndpoints();
//			cmp3 = new OrderXLines();

			cmp2 = new OrderYLines();
			treeEndpoints = new RedBlackTree();
      
			status.setText("start Sweeping ...");

			sortPoints = readEndpoints.toArray();
			Arrays.sort(sortPoints, cmp1);
			
      minNode = new Node((Endpoint)sortPoints[0]); //Knoten mit dem kleinsten X-Wert
			
			minEndpoint =(Endpoint)sortPoints[0]; 
			noOfLines = 0;
		      int i = 0;
		      
		      //Knoten werden in den Rot-Schwarz Baum eingefuegt
		      while (i<sortPoints.length)
		      {
		      	minEndpoint = (Endpoint)sortPoints[i];
            Node TempNode = new Node(minEndpoint);
		        endpoints.insert(TempNode);
		        i++;
		      }
		    
			iSweep = 0;
			xSweep = 0;
			yMax = theWhiteBoard.getBounds().height;
			xMax = theWhiteBoard.getBounds().width;
			pointOne = new Point(xSweep, 0, cSweep);
			pointTwo = new Point(xSweep, yMax, cSweep);
			Line = new Line (pointOne, pointTwo," ", 0);
			figures.addElement( Line );
//			repaint();

		}
		/*********************************************
		 *
		 *********************************************/
		public void goSweep() {
			
      Point q1 = null, q2 = null, aPoint = null;
			figures.removeElementAt(figures.size()-1);
			xSweep = minEndpoint.getX();
			iSweep++;
				
			minNode = endpoints.search(minNode);
			minEndpoint = ((Endpoint)(minNode.getKey()));
			xSweep = minEndpoint.getX();  //Die Sweep Linie befindet sich nun an diesem Punkt
			
			
			status.setText("Sweeping ..."+iSweep);
			
			//Fall A: Die Sweep-Linie erreicht den linken Endpunkt einer Linie
			if (minEndpoint.getT()=='L')
			{
			   Node lineNode = new Node((Line)minEndpoint.getLine());
			   //A.1: Da Linie L aktiv wird, setzen wir es in die Datenstruktur Y(yStructure) ein.
			   yStructure.insert(lineNode);
         
			   //A.2.1: Wir suchen nach der Linie L' in Y , welche direkt oberhalb von L ist (d.h., der Nachfolger von L)
			   Node succesor = (Node)yStructure.successor(lineNode);
			   //A.2.2: Nun suchen wir nach der Linie L'' in Y, welche sofort unterhalb von L ist (d.h., der Vorgnger von L)
			   Node predecessor = (Node)yStructure.predecessor(lineNode);
			   
			   
			   //A.2.3: Prfen ob sich L und L' berschneiden
			   if (succesor.getKey()!=null&&succesor.getKey() instanceof Line){
			   	 
				   q1 = ((Line)succesor.getKey()).getP1();
				   q2 = ((Line)succesor.getKey()).getP2();
				   aPoint = ((Line)lineNode.getKey()).intersect(q1, q2);
				   
		   		   if (aPoint != null)
				   {
           
						results.add("("+((Line)lineNode.getKey()).getL()+", "+((Line)succesor.getKey()).getL()+") = ("+ aPoint.getX() + ", " + aPoint.getY() + ")");
						endpoints.insert(new Node(new Endpoint(new Line(new Point(aPoint.getX(),aPoint.getY(),Color.green),new Point(aPoint.getX()+1,(aPoint.getY()+1),Color.black), "Intersection",iSweep),((Line)lineNode.getKey()), ((Line)succesor.getKey()),'I')));
						figures.addElement(aPoint);
						
					}
				}
			   
                //A.2.4: Prfen ob sich L und L'' berschneiden
			    if (predecessor.getKey()!=null&&predecessor.getKey() instanceof Line){
				  
				   
                   q1 = ((Line)predecessor.getKey()).getP1();
				   q2 = ((Line)predecessor.getKey()).getP2();
				   aPoint = ((Line)lineNode.getKey()).intersect(q1, q2);
				   
				   if (aPoint != null)
				   {
						results.add("("+((Line)lineNode.getKey()).getL()+", "+((Line)predecessor.getKey()).getL()+") = ("+ aPoint.getX() + ", " + aPoint.getY() + ")");
						endpoints.insert(new Node(new Endpoint(new Line(new Point(aPoint.getX(),aPoint.getY(),Color.green),new Point(aPoint.getX()+1,(aPoint.getY()+1),Color.black), "Intersection",iSweep),((Line)lineNode.getKey()), ((Line)predecessor.getKey()),'I')));
						figures.addElement(aPoint);
						
					}
			    }
			//Fall B: Die Sweep-Linie erreicht den rechten Endpunkt einer Linie    
			} else if (minEndpoint.getT()=='R'&&iSweep>=1)
			{
				
			     Node lineNode = new Node((Line)minEndpoint.getLine());
		               
		         //if (lineNode!=null)lineNode = (Node)yStructure.search(lineNode);
		         
			     
			     if (lineNode.getKey()!=yStructure.getNil()&&lineNode.getKey() instanceof Line){
		         
			     	 // B.1: Wir suchen in Y den Nachfolger L' und den Vorgnger L'' von L.                                                  
			     	 Node predecessor = (Node)yStructure.predecessor(lineNode);
		             Node succesor = (Node)yStructure.successor(lineNode);
			         
		             /* B.3: Wir prfen, ob L' und L'' sich auf der rechten Seite der Sweep-Linie schneiden. Wenn sie dies
					    tun, setzen wir ihren Schnittpunkt in die X ein.                                                      */
			         if (predecessor!=null&&predecessor!=yStructure.getNil()&&succesor!=yStructure.getNil()) {
			             q1 = ((Line)predecessor.getKey()).getP1();
			             q2 = ((Line)predecessor.getKey()).getP2();
			             aPoint = ((Line)succesor.getKey()).intersect(q1, q2);
			            
			             
			             if (aPoint!=null&&((aPoint.getX()-xSweep) > 0)){
			             
			                 figures.addElement(aPoint);
			                 endpoints.insert(new Node(new Endpoint(new Line(new Point(aPoint.getX(),aPoint.getY(),Color.green),new Point(aPoint.getX()+1,(aPoint.getY()+1),Color.black), "Intersection",iSweep),((Line)succesor.getKey()), ((Line)predecessor.getKey()),'I')));
			                
			             }
					          
			          }
			         
			          //B.2: Wir lschen die Linie L aus der Datenstruktur Y.
		              yStructure.delete(new Node((Line)minEndpoint.getLine())); 
		         }
		         
		         
		         
         
			//Fall C: Die Sweep-Linie trifft auf einen Schnittpunkt zweier Linien L1 und L2
			} else if (minEndpoint.getT()=='I') 
			{
			         Node Line1Successor = null;
			         Node Line2Predecessor = null;
			         Node Line1 = null;
			         
					 Line Intersection = (Line)minEndpoint.getLine();
					 //C.1: Wir geben den Schnittpunkt (L1,L2) aus.
			         figures.addElement(((Point)Intersection.getP1()));
					 numberIntersections++;
			         
			        
			         Line1 = new Node((Line)minEndpoint.getLine1());
			         //Line1 = (Node)yStructure.search(Line1);
			         
			         //C.2.1: Wir suchen in Y den Nachfolger L' von L1
			         if (Line1!=null&&Line1!=yStructure.getNil()) {
			         
			             Line1Successor = (Node)yStructure.successor(Line1);
			             yStructure.delete(Line1);
			             
			         }
			         
			         
			         Node Line2 = new Node((Line)minEndpoint.getLine2());
			         //Line2 = (Node)yStructure.search(new Node((Line)minEndpoint.getLine2()));
			        
			         //C.2.2: Wir suchen in Y den Vorgnger L'' von L2
			         if (Line2!=null&&Line2!=yStructure.getNil()) {
			             
			             Line2Predecessor = (Node)yStructure.predecessor(Line2);
			             yStructure.delete(Line2);
			             
//			           
			             //C.3.1: Wir testen ob L1 und L'' sich auf der rechten Seite der Sweep-Linie schneiden.Falls ja setzen wir ihren Schnittpunkt in X ein.
				         if (Line2Predecessor!=null&&Line2Predecessor!=yStructure.getNil()) {
			             
			               Line2PredecessorPoint1 = ((Line)Line2Predecessor.getKey()).getP1();
						   Line2PredecessorPoint2 = ((Line)Line2Predecessor.getKey()).getP2();
			               Point aPoint2 = ((Line)Line1.getKey()).intersect(Line2PredecessorPoint1, Line2PredecessorPoint2);
			               
			               if (aPoint2!=null&&((aPoint2.getX()-xSweep) > 0)) {
			               	
			               	 figures.addElement(aPoint2);
			               	 endpoints.insert(new Node(new Endpoint(new Line(new Point(aPoint2.getX(),aPoint2.getY(),Color.green),new Point(aPoint2.getX()+1,(aPoint2.getY()+1),Color.black), "Intersection",iSweep),((Line)Line1.getKey()), ((Line)Line2Predecessor.getKey()),'I')));
							
			               }
			            }  
			         
			         }
			         
			         //C.3.2: Wir testen ob L2 und L' sich auf der rechten Seite der Sweep-Linie schneiden.Falls ja setzen wir ihren Schnittpunkt in X ein.
			         if (Line1!=null&&Line1Successor!=yStructure.getNil()&&Line1Successor!=null){
			         
			            Line1SuccessorPoint1 = ((Line)Line1Successor.getKey()).getP1();
			            Line1SuccessorPoint2 = ((Line)Line1Successor.getKey()).getP2();
			            aPoint = ((Line)Line2.getKey()).intersect(Line1SuccessorPoint1, Line1SuccessorPoint2);
			            
			            if (aPoint!=null&&((aPoint.getX()-xSweep) > 0)) {
			            	
			            	figures.addElement(aPoint); 
			            	endpoints.insert(new Node(new Endpoint(new Line(new Point(aPoint.getX(),aPoint.getY(),Color.green),new Point(aPoint.getX()+1,(aPoint.getY()+1),Color.black), "Intersection",iSweep),((Line)Line2.getKey()), ((Line)Line1Successor.getKey()),'I')));
							
			            }
			         }  
			         
			         
			        yStructure.insert(new Node((Line)minEndpoint.getLine2()));
			        yStructure.insert(new Node((Line)minEndpoint.getLine1()));     
			          

         

			    
			}
			
		    newMinNode = endpoints.successor(minNode); //Der momentan kleinste Endpunkt
		    if (minNode!=endpoints.getNil()) endpoints.delete(minNode);     //Loeschen des kleinsten Knotens		
            minNode = newMinNode;
    
			//Plane-Sweep
            pointOne.setPoint(xSweep, 0, cSweep);
			pointTwo.setPoint(xSweep, yMax, cSweep);
			Line.setLine(pointOne, pointTwo, " ", 0);
			figures.addElement(Line);
			
			repaint();
		}
		
		/*********************************************
		 *
		 *********************************************/
		public void sweep() {


			initSweep();
			stepFlag = 1;
			

			while (iSweep<sortPoints.length+numberIntersections)
			{
				goSweep();
			}
			status.setText("All the steps are finished.");
		}
			
		/*********************************************
		 *
		 *********************************************/
		public void showStep() {

			if (stepFlag == 0)
			{
				initSweep();
				stepFlag = 1;
			}
				
			if (iSweep<sortPoints.length+numberIntersections)
			{
				goSweep();
			}else
			{
				status.setText("All the steps are finished.");
			}
		}
		/*********************************************
		 *
		 *********************************************/
		public void mouseClicked(MouseEvent e) { 
		}
	  	public void mouseEntered(MouseEvent e) {
			setCursor( new Cursor(Cursor.CROSSHAIR_CURSOR) );
		}
		public void mouseExited(MouseEvent e) {
			setCursor( new Cursor(Cursor.DEFAULT_CURSOR) );
		}
		public void mouseMoved(MouseEvent e) {
		}
		public void mouseDragged(MouseEvent e) {
			if (stepFlag == 0)
			{
			
//				status.setText( "mouse dragged" );
	
				pointTwo.setPoint( e.getX(), e.getY(), currentColor );
				Line.setLine(pointOne, pointTwo, lLabel, noOfLines);
//				if (figures.size() >1)
				{
					figures.set(figures.size()-2, pointTwo);
				}
//				if (figures.size() >0)
				{
					figures.set(figures.size()-1, Line);
				}
				repaint();
			}
		}
		public void mouseReleased(MouseEvent e) {
				theEndpoint = new Endpoint(Line,null,null, 'L');
				readEndpoints.addElement(theEndpoint);
				theEndpoint = new Endpoint(Line, null,null, 'R');
				readEndpoints.addElement(theEndpoint);
				lines.addElement(Line);
	//			status.setText("no of Lines is " + theEndpoint.getL());
		}
		public void mousePressed(MouseEvent e) {

			if (stepFlag == 0)
			{
				noOfLines++; 
				 
				Integer iil = new Integer(noOfLines);
				lLabel = 'L' + iil.toString();
				
 				
        pointOne = new Point( e.getX(), e.getY(), currentColor );
        pointTwo = new Point( e.getX(), e.getY(), currentColor );
				Line = new Line(pointOne, pointTwo, lLabel, noOfLines);
				figures.addElement( pointOne);
				figures.addElement( pointTwo);
				figures.addElement( Line);
				repaint();
			}
		}
	}	
//}

/********************************************************************
 * Interface Figure
 * This interface should be implemented by all drawable objects.  It
 * ensures that there is are uniform methods for drawing
 * objects on the Whiteboard.
 ********************************************************************/
interface Figure {
	public void draw( Graphics g );
}


/********************************************************************
 * Positions on the screen are points and extend to oval, that is a paired
 * x and y coordinate.
 ********************************************************************/
class Point implements Figure {
	int	x;
	int	y;
	int width = 4;
	int height = 4;
	Color c;
	public Point( int ix, int iy, Color ic) {
		x = ix;
		y = iy;
		c = ic;
	}
	public void setPoint( int ix, int iy, Color ic) {
		x = ix;
		y = iy;
		c = ic;
	}
	public void draw( Graphics g ) {
			g.setColor( c );
			g.fillOval( (int)(x-2), (int)(y-2), width, height);
			g.drawOval( (int)(x-2), (int)(y-2), width, height);
	}
	
	public int getX() {
		return (x);
	}

	public int getY() {
		return (y);
	}
}

/********************************************************************
 * A Line is a colored line.
 ********************************************************************/
class Line implements Figure,Comparable {
	Point	p1;
	Point	p2;
	String  l;
	int n;

	public Line( Point ip1, Point ip2, String il, int in) {
		if (ip1.getX() < ip2.getX())
		{
			p1 = ip1;
			p2 = ip2;
		} else
		{
			p1 = ip2;
			p2 = ip1;
		}
		l = il;
		n = in;
	}
	public void setLine( Point ip1, Point ip2, String il, int in) {
		if (ip1.getX() < ip2.getX())
		{
			p1 = ip1;
			p2 = ip2;
		} else
		{
			p1 = ip2;
			p2 = ip1;
		}
		l = il;
		n = in;
	}
	public void draw( Graphics g ) {
		g.setColor(Color.black);
		g.drawLine( p1.x, p1.y, p2.x, p2.y );
		g.drawString(l, (p1.x + p2.x)/2, (p1.y + p2.y)/2);
	}

	public Point intersect(Point q1, Point q2)
	{  
		double d,d1,d2,a1,b1,c1,a2,b2,c2;
		int iX, iY;
		Point aPoint;

		a1=p1.getY() - p2.getY(); 
		b1=p1.getX() - p2.getX(); 
		c1=a1*p1.getX() - b1*p1.getY();

		a2=q1.getY() - q2.getY(); 
		b2=q1.getX() - q2.getX(); 
		c2=a2*q1.getX() - b2*q1.getY();

		d=a2*b1 - a1*b2; 
		d1=b1*c2 - b2*c1; 
		d2=a1*c2-a2*c1;

		if(d!=0.0)
		{
			iX=(int)(d1/d);
			iY=(int)(d2/d);
			if ((iX<p1.getX() & iX<p2.getX()) | (iX<q1.getX() & iX < q2.getX()) 
				| (iX>p1.getX() & iX>p2.getX()) | (iX>q1.getX() & iX >q2.getX())) 
			{
				aPoint = null;
			} else
			{
				aPoint = new Point(iX, iY, Color.red);
			}
		}else
		{
			aPoint = null;
		}
		return (aPoint); 

	}

	public Point getP1() {
		return(p1);
	} 

	public Point getP2() {
		return(p2);
	} 


	public String getL() {
		return(l);
	} 

	public int getN() {
		return(n);
	}
	//Die Linien werden anhand den Y-Koordinaten des Schnittpunktes mit der Sweep-Line sortiert
	public int compareTo(Object obj1)
	{
      		
		  if (!(obj1 instanceof Line))
      throw new ClassCastException("Ein Line object wurde erwartet.");
			Point q2 = new Point(xSweep, yMax, cSweep);
			Point q1 = new Point(xSweep, 0, cSweep);

			Point p1 = this.getP1();
			Point p2 = this.getP2();
			Line vLine1 = new Line(p1, p2, " ", 0);
			Point i1 = (Point)(vLine1.intersect(q1, q2));	

			Point p3 = ((Line)obj1).getP1();
			Point p4 = ((Line)obj1).getP2();
			Line vLine2 = new Line(p3, p4," ", 0);
			Point i2 = (Point)(vLine2.intersect(q1, q2));	
			
			int ii = 0;
			if (i1 != null & i2 != null)
			{
				ii= i1.getY() - i2.getY();
			}
			
      /*
      Point p1 = this.getP1();
      Point p3 = ((Line)obj1).getP1();
      int ii = 0;
      ii= p1.getY() - p3.getY();
      */
			return ii;
	} 
}

/********************************************************************
 * Endpoints information: x & y coordinates, type, color.
 ********************************************************************/
class Endpoint implements Comparable{
	Line l,l1,l2;
	char t;
	
	public Endpoint( Line il, Line il1, Line il2, char it) {
		t = it;
		l = il;
    l1 = il1;
    l2 = il2;
	}
	public void setEndpoint( Line il, Line il1, Line il2, char it) {
		t = it;
		l = il;
    l1 = il1;
    l2 = il2;
	}

	public int getX() {
		if (t == 'L')
		{
			return (l.getP1().getX());
		} else if (t == 'R')
		{
			return (l.getP2().getX());
		} else
		{
			return (l.getP1().getX());
		}
	}

	public int getY() {
		if (t == 'L')
		{
			return (l.getP1().getY());
		} else if (t == 'R')
		{
			return (l.getP2().getY());
		} else
		{
			return (l.getP1().getY());
		}
	}

	public char getT() {
		return (t);
	}
	
	public char getI() {
		return (t);
	}

	public Line getLine() {
		return (l);
	}
  
	public Line getLine1() {
		return (l1);
	}
  
  public Line getLine2() {
		return (l2);
	}
	public String getLable() {
		return (l.getL());
	}
  
	public int compareTo(Object obj1)
	{
        if (!(obj1 instanceof Endpoint))
        throw new ClassCastException("Ein Endpoint object wurde erwartet.");
				Endpoint p1 = (Endpoint) obj1;
        int xvalue = p1.getX();
        return (this.getX()-xvalue);
      
	}
}

	/*********************************************
	 *
	 *********************************************/
	class OrderXEndpoints implements Comparator {

			 public int compare( Object obj1, Object obj2 )
			{
				Endpoint p1 = (Endpoint) obj1;
				Endpoint p2 = (Endpoint) obj2;
	 
			    return( p1.getX() - p2.getX());
			}
	}

	/*********************************************
	 *
	 *********************************************/
/*	class OrderXLines implements Comparator {

			 public int compare( Object obj1, Object obj2 )
			{
				Point p1 = (Point) ((Line)obj1).getP1();
				Point p2 = (Point) ((Line)obj2).getP1();
	 
			    return( p1.getX() - p2.getX());
			}
	}
*/
	/*********************************************
	 *
	 *********************************************/
	class OrderYLines implements Comparator {

		public int compare( Object obj1, Object obj2 )
		{
			Point q2 = new Point(xSweep, yMax, cSweep);
			Point q1 = new Point(xSweep, 0, cSweep);

			Point p1 = ((Line)obj1).getP1();
			Point p2 = ((Line)obj1).getP2();
			Line vLine1 = new Line(p1, p2, " ", 0);
			Point i1 = (Point)(vLine1.intersect(q1, q2));	

			Point p3 = ((Line)obj2).getP1();
			Point p4 = ((Line)obj2).getP2();
			Line vLine2 = new Line(p3, p4," ", 0);
			Point i2 = (Point)(vLine2.intersect(q1, q2));	
			
			int ii = 0;
			if (i1 != null & i2 != null)
			{
				ii= i1.getY() - i2.getY();
			}
      
			return( ii);
		}
	}

}
